# =====================================================================
# $Id: BEGIN.awk 47 2009-08-03 15:46:35Z carlo $
#
# AWK functions for Shell-Ware Utilities.
# 
# Copyright (c) 2006,2008 Carlo Strozzi
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; version 2 dated June, 1991.
# 
# This program is distributed in the hope that it will be useful,  
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
# =====================================================================

BEGIN {

  _NULL = ""

  # The CMD global variable is used to hold system commands. It is
  # a global name because AWK can have only one system command opened
  # at a time, and the current command needs to be closed before a new
  # one can be opened.

  _CMD = _NULL

  # Generic error code.
  _EFAULT	= 255

  # Linux-style symbolic error codes (see errno(3) and <errno.h>).
  _ENOENT	=   2
  _EIO		=   5
  _EACCES	=  13
  _EISDIR	=  21
  _EINVAL	=  22
  _ENOMSG	=  42
  _EMSGSIZE	=  90

  # Various flags and misc. names.
  _TRUE = _ERRNO = 0
  _FALSE = _EOF = _O_MIDDLE = _O_STRICT = _O_SHORT = 1
  _O_CRUSH = 2

  _BASE64 = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/"

  _CHARSIZE = 1				# default is 8-bit encoding.

  # Get local settings.
  _SWUINST = ENVIRON["SWU_INSTALL"]

  # Set default values if necessary.
  if (_SWUINST !~ /^\//) _SWUINST = "/usr/local/swu"

  # Load the UTF-8 charset.
  _setchar("utf-8")
}

